c
c     Regressions with canonical variates to obtain
c     significance levels of coefficients
c 
c	With 50 years of PCs using the Connor/Koraczyk method
c        and eigenvalues and vectors from SigA and SigB matrices
c
	parameter (nk=27,nob=120,nm=17,nfac=17,npc=10,ndec=5,kx=18)
	real*8 sumv
c        increase dimensions of a and b when there are more than 
c        sqrt(1000) variables in total

	character mname(12)*3
      dimension ivin(nk),pcin(npc),pc(120,npc),ans(5),bans(5)
     &,eigwta(nfac,npc),eigwtb(npc,npc),canva(nob,npc),canvb(nob,npc)
	character*8 statname(9)
	integer year,mon,ykeep(nob,ndec),mkeep(nob,ndec)
     &,fin(nfac)
      dimension iops(10), x(nob,kx),e(nob),yy(nfac),xx(nfac,2)
     1, z(nob,kx),y(nob),facin(nfac),facval(nob,nfac,ndec)
     
      common /regout/bb(60),sb(60),t(60),xbar(60),std(60),rho(60),
     1 rans(5),rhox(1770),covb(1770),dw,se,sr,emax,emin
     2,yans(5),eans(5),akaike,schwartz

	character*8 xnames(kx),yname,junk,facnam(nfac)
     &,pcnam(npc),facnamin(nfac)
	character*50 filename,filewts
	data statname/'    Mean','  Median','   Sigma'
     &,'  T-Stat','     MAD','Skewness'
     &,'Kurtosis',' Maximum',' Minimum'/,iops/0,0,1,0,0,5*0/
     &,ivin/10*1,7*0,3*1/,facval/10200*-9999./
     &,mname/'Jan','Feb','Mar',
     &'Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'/
     &,fin/17*1/

	open(6,file='Canon variates regressions.out'
     &,status='unknown')
         open(9,file='Canon variates regressions.dat'
     &,status='unknown')      
         idecade=1
        open(5,file='Canon variates regressions.in',status='old')
c
c        file with candidate factors
c
        open(2,file='All Plus Mimicks 196801_201506.prn',status='old')
        read(2,5523)facnam
5523        format(8x,17(4x,a8))
c
c        file with eigenvectors from SigA and SigB
c
        open(8,file='Canonical weights decade 1.prn',status='old')
        nfinc=0
        write(6,5522)
5522        format(/'Candidate Factors Included')
        do 872 mm=1,nfac
        if(fin(mm).eq.0)go to 872
        nfinc=nfinc+1
        write(6,5521)facnam(mm)
872        continue
5521	format(5x,a8)
200	continue

	read(2,522,end=201,err=98)year,mon,(facin(mk),mk=1,nfac)
522        format(2x,i4,i2,17g12.4)
c        write(6,522)year,mon,(facin(mk),mk=1,nfac)

        if(year.lt.1965.or.year.gt.2014)go to 200
c        write(6,522)year,mon,(facin(mk),mk=1,nfac)
c        if(idecade.eq.1)stop
        monnum=(year-1965)*12+mon
        kdec=(monnum-1)/nob+1
        j=mod(monnum-1,nob)+1
        ykeep(j,kdec)=year
        mkeep(j,kdec)=mon
c        if(j.eq.1.or.j.eq.nob)write(6,523)year,mon,kdec,j
        
523        format('date check',4i5)
        do 202 mk=1,nfac     
        facval(j,mk,kdec)=facin(mk)
202        continue
       go to 200
201        continue
        
100	continue
        read(5,51,end=1000)filename
        read(5,51,end=1000)filewts
51        format(a50)
        write(6,5511)idecade,filename,filewts
5511        format(/'Decade ',i1,', CKPC file: ',a50/
     &8x,'  Eigenfile: ',a50)

c	open(7,file='cancorr 50 CK.dat',status='unknown')
c
c        read the CK PCs for this decade
c
       
        open(3,file=filename,status='old')  
        open(8,file=filewts,status='old') 
        j=1
10        continue
	read(3,52,end=11)(pcin(m),m=1,npc)
52        format(10f12.6)
        do 1 m=1,npc
        pc(j,m)=pcin(m)
1        continue
        j=j+1
        if(j.le.nob)go to 10
11        continue  

579        format(i2)
c
c        read eigenvector weights for this decade
c
        read(8,577,end=1000)junk
        read(8,577)junk
577        format(a8)
        do 12 ii=1,nfac
        read(8,576)facnamin(ii),(eigwta(ii,ll),ll=1,npc)
12        continue
 
        read(8,577)junk
        read(8,577)junk
        read(8,577)junk
        do 13 ii=1,npc
        read(8,576)pcnam(ii),(eigwtb(ii,ll),ll=1,npc)
13        continue
576        format(a8,7x,10f12.6) 
c        write(6,5576)
5576        format('Eigenvectors in')
        if(idecade.eq.1)write(9,5577)(facnamin(ii),ii=1,nfac)
5577        format(5x,'CanCorr',3x,17(1x,a8)) 
c
c        compute canonical variates for CK PC factors
c        and for non-missing candidate factors
c
c        zero out canonical variates for candidates
c
        do 22 j=1,nob
        do 23 ll=1,npc
        canva(j,ll)=-9999.
23        continue
22        continue
 
     
        do 14 j=1,nob
        do 16 ll=1,npc
        sumv=0.d0
        do 15 m=1,npc
        sumv=sumv+pc(j,m)*eigwtb(m,ll)
15        continue
        canvb(j,ll)=sumv
        sumv=0.d0
        do 17 m=1,nfac
        if(fin(m).eq.0)go to 17
        if(facval(j,m,idecade).lt.-998.)go to 17
        sumv=sumv+facval(j,m,idecade)*eigwta(m,ll)
17        continue
        canva(j,ll)=sumv
        
16        continue
14        continue
 
c
c  first run canonical variates from CK PCs on candidate canonical variates
c
        kin=0
        do 25 m=1,nfac
        if(fin(m).eq.0)go to 25
        kin=kin+1
        xnames(kin)=facnamin(m)
25        continue

 
        xnames(kin+1)='Constant'
        do 121 ll=1,npc
c        write(6,5121)ll
5121        format(/'Canonical Regression No. ',i2/)
        iops(1)=1
        if(ll.eq.1)iops(1)=0
        nin=0
        do 122 j=1,nob
        do 123 m=1,nfac
        if(fin(m).eq.0)go to 123
        if(facval(j,m,idecade).lt.-.998)go to 122
123        continue
        nin=nin+1
        y(nin)=100.*canvb(j,ll)
        kin=0
        do 124 m=1,nfac
        if(fin(m).eq.0)go to 124
        kin=kin+1
        x(nin,kin)=100.*facval(j,m,idecade)
124        continue
c        write(6,5122)j,nin,kin,y(nin),x(nin,1),x(nin,kin)
5122    format(3i4,3g12.4)
122        continue
        kk=kin+1

        yname=pcnam(ll)
        call reg(x,y,z,e,nin,kk,nob,kx,iops,yname,xnames,*98)
        do 181 mm=1,kk
        t(mm)=abs(t(mm))
181        continue
        
      cancorr=sqrt(1.-se**2/rans(2)**2)
        if(iops(1).eq.0)write(6,5170)cancorr
5170   format(/'Canonical Correlation: ',g16.9/)
        write(9,5172)idecade,ll,cancorr,(t(mm),mm=1,kk-1)
5172  format(i1,i3,f8.4,17f9.3)
        do 170 mm=1,nfac
        yy(mm)=eigwta(mm,ll)
        xx(mm,1)=bb(mm)
170        continue
        call stats(yy,nfac,ans)
        call stats(xx,nfac,bans)
        do 171 mm=1,nfac
        yy(mm)=(yy(mm)-ans(1))/ans(2)
        xx(mm,1)=(xx(mm,1)-bans(1))/bans(2)
171        continue
        yname='eigwta'
        xnames(1)='B Coeff'
        call reg(xx,yy,z,e,nfac,2,nfac,2,iops,yname,xnames,*98)
        
121        continue


        idecade=idecade+1
        close (3)
        go to 100
1000	continue
	stop

98	write(6,599)
599	format('Error')
	stop
	end

c  standard regression
c  program now does up to 60 variables.  larger program is possible.
c  see rroll for method to compile this larger program
c  the following fortran statement will do the regression.
c         call reg(x,y,z,e,n,k,nn,kk,iops,yname,xnames,*j)
      subroutine reg(x,y,z,e,n,k,nn,kk,iops,yname,xnames,*)
c  x is the matrix of explanatory variables dimensioned nn x kk in calling program
c  y is the vector of the dependent variable.  
c  e is the vector of residuals
c  n is the number of observations
c  k is the total number of variables (x + y)
c  z is (n x k) work matrix.  a column of 1's is added to z(,k)
c  the first k - 1 variables in x are used in the regression
c  if z and x are input the same argument, x must contain an extra colum
c  if x'x is singular, return is to statement j, which must be a label in the calling program
c  in this case, the output b's are all equal to -999999.
c
c  iops is vector of options
c  iops(1) ne 0 suppresses all printed output
c  iops(2) ne 0 prints the table of residuals
c  iops(3) ne 0 does extended residual analysis
c  iops(4) ne 0 prints the corelation matrix of the coefficients
c  iops(5) ne 0 prints the correlation matrix of the independent variables
c  iops(6) ne 0 prints the input variables
c  iops(7) ne 0 prints a normal probability plot of the residuals
c
c  yname is an A8 name for the dependent variable
c  xnames is a k x 1 vector of A8 names for the explanatory variables
c
      dimension iops(10), x(nn,kk),e(n)
     1, z(n,k),y(n),xnames(k),corrb(60)
      common /regout/b(60),sb(60),t(60),xbar(60),std(60),rho(60),
     1 ans(5),rhox(1770),covb(1770),dw,se,sr,emax,emin
     2,yans(5),eans(5),akaike,schwartz
	character*8 xnames,yname,intname
c
c  internal output is obtained in the common block 'regout'
c
c  b(kk) is regression coefficient vector
c  sb(kk) is standard error vector
c  t(kk) is t statistics vector
c  xbar(kk) and std(kk) are mean and standard deviation vectors of vbls.
c  rhox is correlation coefficient matrix of ind. variables
c       this matrix is stored as lower left triangle
c       i.e., r12,r13,r23,r14,r24,r34,...
c  covb is COVARIANCE matrix of the coefficients
c       this matrix is stored as lower left triangle including the diagonal
c       i.e., c11,c12,c22,c13,c23,c33,...
c	  Note: the correlation matrix of the coefficients printed and the 
c	        coveriance matrix is retained internally on the regout common block
c  ans(1) is mean of y
c  ans(2) is std. dev. of y
c  ans(3) is r**2 (adjusted)
c  ans(4) is std. error of estimate
c  ans(5) is f statistic for the regresssion
c  dw is durbin-watson statistic
c  se is std. dev. of residuals
c  sr is studentized range of residual distribution
c  emax is maximum residual
c  emin is minimum residual
c  xnames is vector (a8) of explanatory variable names
c  yname is (a8) name of dependent variable
c  yans and eans are stats vectors for dependent variable and residuals
c	1	mean
c	2	standard deviation
c	3	mean absolute deviation
c	4	skewness
c	5	excess kurtosis
c  akaike is the log of the Akaike Criterion
c  schwartz is the log of the Schwartz Criterion
c
	intname='Constant'
      m=k
      ka=k-1
      io=1
      
    3 format(9h Variable,4x,4hMean,5x,
     &8hStandard,'     Corr.',2x,
     &10hRegression,6x,5hT    ,2x,10h Standard 
     &/6h    x ,16x,9hDeviation,
     &1x,8h  x vs y,2x,11hCoefficient,3x,5hValue,4x,11h   Error    /1x)
    4 format(1h ,a8,1x,2g11.3,f8.4,1x,2g12.4,g11.3)
  544 format(1h ,a8,1x,2g11.3,2g12.4)
    5 format(1h /10hDependent ,23x,'Skewness     Kurtosis')
6     format(10h Constant ,31x,2g12.4,g11.3)
56    format(1x/1x,'     Adjusted R-Square:',
     1g12.5,3x,'Std. Error of Estimate:',g12.5/
     &1x,          '  Ln(Akaike Criterion):',g12.5
     &,3x,     'Ln(Schwartz Criterion):',g12.5/
     & ' Regression F(',i2,'/',i5,'):',g12.5,14x,'Sample Size:',i5)
   10 format(36i2)
11    format(1h ,15x//29x,18hTable of Residuals/1x//
     &1x,2(12h    Obs. No.,
     15x,7hy value,2x,10h  Residual,2x))
   12 format(1h /2(1x,i7,5x,g15.5,g11.4))
      call easyrg
     &(x,y,e,z,n,k,nn,kk,b,sb,t,covb,rho,rhox,ans,xbar,std,deter,*99)
	
        call stats(y,n,yans)
	call stats(e,n,eans)
	xnnn=n
	sslog=log(((xnnn-1.)/xnnn)*eans(2)**2)
	akaike=sslog+2.*k/n
	schwartz=sslog+k*log(xnnn)/n
      if(iops(1).ne.0)go to 144
      write(6,3)
      
      do 115 j=1,ka
  115 write(6,4)xnames(j),xbar(j),std(j),rho(j),b(j),t(j),sb(j)
      fstat=ans(5)
      ndfn=k-1
      ndfd=n-k
      write(6,6)b(k),t(k),sb(k)
      write(6,5)
      write(6,544)yname,ans(1),ans(2),yans(4),yans(5)
      write(6,56)ans(3),ans(4),akaike,schwartz,ndfn,ndfd,fstat,n
  144 continue
 
	if(iops(4).eq.0.or.iops(1).ne.0)go to 130
      write(6,141)(xnames(i),i=1,k-1)
141	format(/13x,'Correlation matrix of coefficients'/
     1/(12x,10(a8,2x)))
	ie=0
      do 133 i=1,k
	ib=ie+1
	ie=ie+i
	mm=0
	do 134 kr=ib,ie
	mm=mm+1
134	corrb(mm)=covb(kr)/(sb(mm)*sb(i))
	if(i.eq.1)go to 133
	if(i.lt.k)then
	write(6,155)xnames(i),(corrb(mj),mj=1,mm-1)
	else
	write(6,155)intname,(corrb(mj),mj=1,mm-1)
	endif
133	continue
155	format(2x,a8,10f10.5/(10x,10f10.5))

130	continue
      kr=0
      ka=k-1
      kb=k-2
      if(iops(5).eq.0)go to 30
      if(kb.le.0)go to 30
      do 31 i=2,ka
      li=i-1
      do 32 ii=1,li
      kr=kr+1
   32 rhox(kr)=(rhox(kr)/n-xbar(i)*xbar(ii))/(std(i)*std(ii))
   31 continue
      if(iops(1).ne.0)go to 30
      write(6,14)(xnames(i),i=1,kb)
   14 format(/13x,'Correlation coefficients of independent variables'/
     1/(12x,10(a8,2x)))
      ie=0
      do 33 i=1,kb
      klx=i+1
      ib=ie+1
      ie=ie+i
   33 write(6,15)xnames(klx),(rhox(kr),kr=ib,ie)
   15 format(2x,a8,10f10.5/(10x,10f10.5))
   30 continue
      if(iops(1).ne.0)go to 143
      if(iops(6).eq.0)go to 40
      call wrx(z,y,n,k)
   40 continue
      if(iops(2).eq.0)go to 143
      write(6,11)
  142 write(6,12)(j,y(j),e(j),j=1,n)
  143 continue
 
      if(iops(3).eq.0)go to 999
c   calculate durbin-watson and other residual statistics
      emax=e(1)
      suma=0.
      emin=e(1)
      sumb=e(1)**2
      sumc=abs(e(1))
      do 150 i=2,n
      if(e(i).gt.emax)emax=e(i)
      if(e(i).lt.emin)emin=e(i)
      sumc=sumc+abs(e(i))
      suma=suma+(e(i)-e(i-1))**2
  150 sumb=sumb+e(i)**2
      sumc=sumc/n
      dw=suma/sumb
      se=sqrt(sumb/n)
      sr=(emax-emin)/se

c
c	jarque/bara statistic
c
	sterm=(eans(4)**2/(n-1))*n
	skterm=((eans(5)+3.)/(n-1))*n
	xjarqb=(n/6.)*(sterm+(skterm-3.)**2/4.)
	chipv=chisqr(2.,xjarqb)
	xn=n
	lags=alog(xn)
	if(lags.le.1)lags=1 
	xljungb=xungbox(e,n,lags)
	xlags=lags
	chipl=chisqr(xlags,xljungb)

      if(iops(1).eq.0)then
	write(6,13)se,sr,sumc,dw,xljungb,xjarqb
     &,emax,emin,eans(4),eans(5)
     &,chipl,chipv
   13 format(1h /15x,'Analysis of Residuals'//
     &,'   Standard   Studentized  Mean Absolute'
     &,'   Durbin       Ljung        Jarque'/
     &,'  Deviation      Range       Deviation   '
     &,'  Watson        Box          Bara'/
     &1x,6g13.5/3x
     &,'Maximum      Minimum     Skewness      Kurtosis',11x,'p-values'/
     &1x,6g13.5)
	endif
  999 continue

      if(iops(1).ne.0)return
	if(iops(7).eq.0)return
c
c	print normal probability plot of residuals using z(,1) 
c       as residual matrix and z(,2) as scratch matrix
c
	do 241 j=1,n
	z(j,1)=e(j)
241	continue
	call normplot(n,z,z(1,2),10,80,65)
      return
 
99	continue
c	
c	error (singular explanatory variable matrix)
c
	do 598 mmk=1,k
	b(mmk)=-999999.
598	continue
	if(iops(6).eq.0)go to 998
      write(6,50)deter
   50 format(1h ,2x,'near - singularity in xtx , determinant = ',d14.4,'
     1 regression not computed')
	call wrx(z,y,n,k)
998	return 1
      end


	function xungbox(e,n,l)
c
c	ljung/box statistic for e with lags=l
	dimension e(n)
	real*8 sum,sumt
	sumt=0.d0
	do 1 m=1,l
	nn=n-m
	rho=correl(e(1),e(m+1),nn)
	if(abs(rho).gt.1.)write(6,5999)rho

5999	format('Ljung/Box error ',g16.9)
	sum=sum+rho**2/nn
1	continue
	xungbox=sum*n*(n+2)
	return
	end


	function correl(y,x,n)
c
c	simple correlation of y and x
c
	dimension y(n),x(n)
	real*8 sumx,sumy,sumxy,xbar,ybar,sumx2,sumy2
	sumx=0.d0
	sumy=0.d0
	sumxy=0.d0
	sumx2=0.d0
	sumy2=0.d0
	do 1 j=1,n
	sumx=sumx+x(j)
	sumy=sumy+y(j)
1	continue
	xbar=sumx/n
	ybar=sumy/n
	do 2 j=1,n
	sumx2=sumx2+(x(j)-xbar)**2
	sumy2=sumy2+(y(j)-ybar)**2
	sumxy=sumxy+(x(j)-xbar)*(y(j)-ybar)
2	continue
	correl=sumxy/dsqrt(sumx2*sumy2)
	return
	end

      SUBROUTINE normplot (n,x,y,nxl,nx,ny)
c	
c	Normal probability plotter
c
c	n	the number of observations
c	x	vector of observations
c       y       scratch vector passed with at least n elements
c	nxl	number of x axis labels minus 1 (max = 21)
c	nx	characters on x axis (approximately 80 for 8.5 X 11) max=80
c	ny	lines on pdf axis (approximately 65 for 8.5 X 11) max=100
c
c	WARNING: routine sorts the original observations
c	NOTE: The PDF fractiles cannot be exact percentages because
c		there are insufficient pixels on a printed page
c
      DIMENSION K(100),X(n),Ylab(9),ans(5)
     &,xw(21),quants(9,2),idone(9),ilab(9)
	real*8 y(n),yc1,yc2,yrnge,yinc
      CHARACTER *1 K,BLANK,idot,idsh
      DATA BLANK /' '/,IDOT/'|'/,IDSH/'-'/,nyl/100/
     &,quants/1,5,10,25,50,75,90,95,99,9*0./

	call stats(x,n,ans)
	do 211 j=1,n
	x(j)=x(j)/ans(2)
211	continue

      CALL SORT (X,N)

	xn=n+1
	do 111 j=1,n
	zz=j/xn
      call NDTRI(zz,yval,D,IE)
	y(j)=yval
111	continue
	do 112 j=1,9
	call ndtri(quants(j,1)/100.,quants(j,2),d,ie)
112	continue
	do 110 m=1,100
110	k(m)='-'
513	format(//25x,'Normal Probability Plot of Standardized Residuals'/
     &'       PDF'/11x,'+',80a1,'+')
	write(6,513)(k(m),m=1,nx)
	
      XRNGE = X(N) - X(1)
      YMAX = Y(n)
      YMIN = Y(1)
      YRNGE = YMAX - YMIN
	xinc=xrnge/nx
	yinc=yrnge/ny
	xny=ny
	jylab=(ny+1)/nyl
	jxlab=(nx+1)/nxl
	do 62 jj=1,9
	idone(jj)=0
62	continue
	do 1 iy=1,ny
	do 2 m=1,100
	k(m)=blank
2	continue
	do 3 ix=1,nx
	do 4 j=1,n
	xc1=x(1)+xinc*(ix-1)
	xc2=x(1)+xinc*ix
	ii=n-j+1
	yc1=y(n)-yinc*(iy-1)
	yc2=y(n)-yinc*iy
	if(x(ii).ge.xc1.and.x(ii).le.xc2.and.
     &y(ii).le.yc1.and.y(ii).ge.yc2)then
	if(k(ix).eq.blank)then
	k(ix)='o'
	ykeep=y(ii)
	else
	k(ix)='*'
	endif
	endif
4	continue
3	continue
	do 71 ml=1,9
	xtt=(quants(ml,1)/100.)*ny
	ilab(ml)=xtt
	xny=ny
	zdiff=xtt-ilab(ml)
	if(zdiff.ge..5)then
	ilab(ml)=ilab(ml)+1
	if(zdiff.le..5)xny=ny+1
	endif
	ylab(ml)=100.-(ilab(ml)/xny)*100.
71	continue
	do 31 ml=1,9
	mll=ml
	if(ilab(ml).eq.iy)go to 32
31	continue
	go to 33
32	continue
	do 61 m=1,nx
	if(k(m).eq.blank)k(m)='-'
61	continue
	write(6,52)ylab(mll),(k(m),m=1,nx)
52	format(f9.1,'%',1x,'|',80a1,'|')
	go to 1
33	write(6,53)(k(m),m=1,nx)
53	format(11x,'|',80a1,'|')
1	continue

	write(6,531)
531	format(11x,'|',80x,'|')
	do 10 m=1,100
10	k(m)='-'
	iw=0
	do 11 m=1,nx+1
	if(mod(m-1,jxlab).eq.0)then
	iw=iw+1
	k(m)='|'
	xw(iw)=x(1)+xinc*(m-1)
	endif
11	continue
	write(6,510)(k(m),m=1,nx)
510	format(11x,'+',80a1,'|')
	write(6,512)(xw(mm),mm=1,iw)
512	format(6x,11f8.1)
	write(6,516)
516	format(41x,'Standardized Residual')


      RETURN
      END

 
      SUBROUTINE NDTRI(P,X,D,IE)
C INVERSE NORMAL DISTRIBUTION FUNCTION
C P IS CDF, X IS CORRESPONDING NORMAL VARIATE, D IS DENSITY AT P
      IE=0
      X=.99999E+28
      D=X
      IF(P)1,4,2
    1 IE=-1
      GO TO 12
    2 IF (P-1.0)7,5,1
    4 X=-.999999E+28
    5 D=0.0
      GO TO 12
    7 D=P
      IF(D-0.5)9,9,8
    8 D=1.0-D
    9 T2=ALOG(1.0/(D*D))
      T=SQRT(T2)
      X=T-(2.515517+0.802853*T+0.010328*T2)/(1.0+1.432788*T+0.189269*T2
     1  +0.001308*T*T2)
      IF(P-0.5)10,10,11
   10 X=-X
   11 D=0.3989423*EXP(-X*X/2.0)
   12 RETURN
      END
 
 
        SUBROUTINE SORT(A,N)
C
C       THIS SUBROUTINE PERFORMS AN IN PLACE SORT OF A
C       ONE DIMENSIONAL ARRAY USING THE SHELL-METZNER
C       METHOD.
C
C       A =  THE ARRAY TO BE SORTED TO ASCENDING ORDER
C       N =  THE NUMBER OF ELEMENTS IN THE ARRAY
C       T =  TEMPORARY ELEMENT HOLDER FOR SWAP
C
        DIMENSION A(1)
C
        K=N
   5    IF (K.LE.1) GOTO 30
         K=K/2
           DO 20 J=1,N-K
            DO 10 I=J,1,-K
             IF (A(I).LE.A(I+K)) GO TO 10
                T=A(I)
                A(I)=A(I+K)
                A(I+K)=T
  10        CONTINUE
  20      CONTINUE
        GOTO 5
C
  30    RETURN
        END
 
 
      subroutine wrx(z,y,n,k)
      dimension z(n,k),y(n)
      ka=k-1
49     format(1h //2x,'Input Matrix'//)
   50 format(1h /1x,8x,'y',7x,'x:',i5,5i11/
     &(19x,i5,5i11))
   51 format(1h ,1x,i3,g11.3,2x,6g11.3/
     &(18x,6g11.3))
   52 format(1h ,1x/)
      write(6,52)
      write(6,52)
      write(6,49)
    1 write(6,50)(i,i=1,ka)
      do 2 j=1,n
2     write(6,51)j,y(j),(z(j,l),l=1,ka)
      return
      end


        subroutine stats(x,n,ans)
c
c  mean, standard deviation, mad, skewness, excess kurtosis,
c	given in output vector a(5), 1,...,5, respectively
c
c	if xob.ne.0, deletes observations less than xob
c
      dimension x(1),ans(5)
      double precision sx,sx2,sx3,sx4,sm,sigx
	sm=0.d0
      sx=0.d0
      sx2=0.d0
      sx3=0.d0
      sx4=0.d0
      do 1 l=1,n
      sx=sx+x(l)
1     continue
      sx=sx/n
	ans(1)=sx
        do 2 l=1,n
        dx=x(l)-sx
	sm=sm+abs(dx)
      sx2=sx2+dx**2
      sx3=sx3+dx**3
      sx4=sx4+dx**4
2	continue
      sx2=sx2/(n-1)
	sigx=dsqrt(sx2)
	ans(2)=sigx
	ans(3)=sm/n
	ans(4)=(sx3/(n-1))/sigx**3.
	ans(5)=(sx4/(n-1))/sigx**4-3.
      return
      end


      subroutine gmprd(a,b,r,n,m,l)
      dimension r(n,l)
      double precision a(n,m),b(m,l),s
      do 1 j=1,n
      do 1 k=1,l
      s=0.d0
      do 3 i=1,m
    3 s=s+a(j,i)*b(i,k)
    1 r(j,k)=s
      return
      end
      subroutine tprd(a,b,r,n,m,msa,msb,l)
      dimension a(1),b(1)
        double precision r(1)
c
c        special case for diagonal by diagonal
c
      ms=msa*10+msb
      if(ms-22)30,10,30
   10 do 20 i=1,n
   20 r(i)=a(i)*b(i)
      return
c
c        multiply transpose of a by b
c
   30 ir=1
      do 90 k=1,l
      do 90 j=1,m
      r(ir)=0.d0
      do 80 i=1,n
      if(ms) 40,60,40
   40 call loc(i,j,ia,n,m,msa)
      call loc(i,k,ib,n,l,msb)
      if(ia) 50,80,50
   50 if(ib) 70,80,70
   60 ia=n*(j-1)+i
      ib=n*(k-1)+i
   70 r(ir)=r(ir)+a(ia)*b(ib)
   80 continue
   90 ir=ir+1
      return
      end
      subroutine loc(i,j,ir,n,m,ms)
c
        kdum=m
      ix=i
      jx=j
      if(ms-1) 10,20,30
   10 irx=n*(jx-1)+ix
      go to 36
   20 if(ix-jx) 22,24,24
   22 irx=ix+(jx*jx-jx)/2
      go to 36
   24 irx=jx+(ix*ix-ix)/2
      go to 36
   30 irx=0
      if(ix-jx) 36,32,36
   32 irx=ix
   36 ir=irx
      return
      end
      subroutine mata(a,r,n,m,ms)
      dimension a(n,m)
      double precision r(m,m),s
      kdum=ms
      do 1 j=1,m
      do 2 l=1,j
      s=0.d0
      do 3 i=1,n
    3 s=s+a(i,j)*a(i,l)
      r(l,j)=s
    2 r(j,l)=s
    1 continue
      return
      end
      subroutine minv(a,n,d,l,m)
      double precision a(1),l(1),m(1),d,biga,hold
      d=1.0d0
      nk=-n
      do 80 k=1,n
      nk=nk+n
      l(k)=k
      m(k)=k
      kk=nk+k
      biga=a(kk)
      do 20 j=k,n
      iz=n*(j-1)
      do 20 i=k,n
      ij=iz+i
   10 if(dabs(biga)-dabs(a(ij))) 15,20,20
   15 biga=a(ij)
      l(k)=i
      m(k)=j
   20 continue
c
c        interchange rows
c
      j=l(k)
      if(j-k) 35,35,25
   25 ki=k-n
      do 30 i=1,n
      ki=ki+n
      hold=-a(ki)
      ji=ki-k+j
      a(ki)=a(ji)
   30 a(ji) =hold
c
c        interchange columns
c
   35 i=m(k)
      if(i-k) 45,45,38
   38 jp=n*(i-1)
      do 40 j=1,n
      jk=nk+j
      ji=jp+j
      hold=-a(jk)
      a(jk)=a(ji)
   40 a(ji) =hold
c
c        divide column by minus pivot (value of pivot element is
c        contained in biga)
c
   45 if(biga) 48,46,48
   46 d=0.0d0
      return
   48 do 55 i=1,n
      if(i-k) 50,55,50
   50 ik=nk+i
      a(ik)=a(ik)/(-biga)
   55 continue
c
c        reduce matrix
c
      do 65 i=1,n
      ik=nk+i
      hold=a(ik)
      ij=i-n
      do 65 j=1,n
      ij=ij+n
      if(i-k) 60,65,60
   60 if(j-k) 62,65,62
   62 kj=ij-i+k
      a(ij)=hold*a(kj)+a(ij)
   65 continue
c
c        divide row by pivot
c
      kj=k-n
      do 75 j=1,n
      kj=kj+n
      if(j-k) 70,75,70
   70 a(kj)=a(kj)/biga
   75 continue
c
c        product of pivots
c
      d=d*biga
c
c        replace pivot by reciprocal
c
      a(kk)=1.0d0/biga
   80 continue
c
c        final row and column interchange
c
      k=n
  100 k=(k-1)
      if(k) 150,150,105
  105 i=l(k)
      if(i-k) 120,120,108
  108 jq=n*(k-1)
      jr=n*(i-1)
      do 110 j=1,n
      jk=jq+j
      hold=a(jk)
      ji=jr+j
      a(jk)=-a(ji)
  110 a(ji) =hold
  120 j=m(k)
      if(j-k) 100,100,125
  125 ki=k-n
      do 130 i=1,n
      ki=ki+n
      hold=a(ki)
      ji=ki-k+j
      a(ki)=-a(ji)
  130 a(ji) =hold
      go to 100
  150 return
      end
      subroutine easyrg
     &(x,y,e,z,n,k,nn,kk,b,sb,t,covb,rho,rhox,ans,xbar,sx,deter,*)
      dimension e(1),z(n,k),x(nn,kk),y(nn),b(1),sb(1),t(1),ans(1)
     1,rhox(1),rho(k),xbar(1),sx(1),covb(1)
      double precision det,xtx(3600),xty(60),igarb(60),ixty(60)
      ka=k-1
      do 1 l=1,ka
      do 1 i=1,n
    1 z(i,l)=x(i,l)
      do 3 i=1,n
    3 z(i,k)=1.
      call mata(z,xtx,n,k,0)
      kr=0
      kb=k-2
      do 8 l=1,kb
      jl=l*k
      do 9 ll=1,l
      kr=kr+1
      ml=jl+ll
    9 rhox(kr)=xtx(ml)
    8 continue
      do 2 l=1,ka
      lap=k*l
      xbar(l)=xtx(lap)/n
      ll=(l-1)*k+l
    2 sx(l)=sqrt(xtx(ll)/n-xbar(l)**2)
      call minv(xtx,k,det,igarb,ixty)
      if(det.le.1.d-19)go to 99
  750 format(1h ,2x,6e12.3,2i6)
      call tprd(z,y,xty,n,k,0,0,1)
      call gmprd(xtx,xty,b,k,k,1)
      sum=0.
      sy=0.
      ybb=xty(k)/n
      do 4 i=1,n
      sy=sy+(y(i)-ybb)**2
      xjunk=y(i)-b(k)
      e(i)=xjunk
      do 5 l=1,ka
    5 e(i)=e(i)-b(l)*z(i,l)
   51 format(1h ,2x,4i5)
    4 sum=sum+e(i)**2
      ssr=sy-sum
      sr=sum/(n-k)
      do 6 l=1,k
      ll=(l-1)*k+l
      sb(l)=sqrt(sr*xtx(ll))
    6 t(l)=b(l)/sb(l)
c
c	covariance matrix of the coefficients
c
	ln=0
	do 16 l=1,k
	do 17 ll=1,l
	lm=(l-1)*k+ll
	ln=ln+1
	covb(ln)=sr*xtx(lm)
17	continue
16	continue
c
      ans(1)=ybb
      ans(3)=1.-sr/(sy/(n-1))
      ans(2)=sqrt(sy/n)
      ans(4)=sqrt(sr)
      ans(5)=(ssr/(k-1))/sr
      do 7 l=1,ka
    7 rho(l)=(xty(l)/n-ans(1)*xbar(l))/(ans(2)*sx(l))
      return
99	deter=det
      return 1
      end

	function chisqr(df,chi2)
	
c
c	returns right tail probability (p-value)
c	corresponding to a chi-square distribution with df degrees of freedom
c
	a=df/2.
	x=chi2/2.
	chisqr=gammq(a,x)
	return
	end

      FUNCTION gammq(a,x)
      REAL a,gammq,x
CU    USES gcf,gser
      REAL gammcf,gamser,gln
      if(x.lt.0..or.a.le.0.)pause 'bad arguments in gammq'
      if(x.lt.a+1.)then
        call gser(gamser,a,x,gln)
        gammq=1.-gamser
      else
        call gcf(gammcf,a,x,gln)
        gammq=gammcf
      endif
      return
      END

      SUBROUTINE gcf(gammcf,a,x,gln)
      INTEGER ITMAX
      REAL a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.e-7,FPMIN=1.e-30)
CU    USES gammln
      INTEGER i
      REAL an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      pause 'a too large, ITMAX too small in gcf'
1     gammcf=exp(-x+a*log(x)-gln)*h
      return
      END
      SUBROUTINE gser(gamser,a,x,gln)
      INTEGER ITMAX
      REAL a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.e-7)
CU    USES gammln
      INTEGER n
      REAL ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
        if(x.lt.0.)pause 'x < 0 in gser'
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      pause 'a too large, ITMAX too small in gser'
1     gamser=sum*exp(-x+a*log(x)-gln)
      return
      END
      FUNCTION gammln(xx)
      REAL gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END




